Index: tracfullblog/templates/fullblog_view.html
===================================================================
--- tracfullblog/templates/fullblog_view.html	(revision 2953)
+++ tracfullblog/templates/fullblog_view.html	(working copy)
@@ -65,51 +65,49 @@
 
           <!--! Add new comment -->
 
-          <h3 id="newcomment">Add New Comment</h3>
-          <form py:if="'BLOG_COMMENT' in perm(blog_post.resource)"
-                action="${req.href.blog(blog_post.name)}#preview" method="post">
-            <fieldset>
-                <div py:if="defined('blog_comment')"
-                        id="preview" class="blog-comment">
-                  <fieldset>
-                    <legend>Comment preview</legend>
-                    <div class="comment-info">
-                      ${blog_comment.author} --
-                      ${format_datetime(blog_comment.time, '%Y-%m-%d %H:%M')}
-                    </div>
-                    <div class="comment_body">${wiki_to_html(context, blog_comment.comment)}</div>
-                  </fieldset>
-                </div>
-                <div class="field">
-                  <label for="comment">Comment (you may use
-                    <a tabindex="42" href="${href.wiki('WikiFormatting')}">WikiFormatting</a>
-                    here):
-                  </label><br />
-                  <textarea class="wikitext" id="comment" name="comment" 
-                    cols="80" rows="8">${defined('blog_comment') and blog_comment.comment or ''}</textarea>
-                </div>
-              <py:if test="req.authname == 'anonymous'">
+          <div py:if="'BLOG_COMMENT' in perm(blog_post.resource)" id="newcomment">
+            <h3>Add New Comment</h3>
+            <form action="${req.href.blog(blog_post.name)}#preview" method="post">
+              <fieldset>
+                  <div py:if="defined('blog_comment')"
+                          id="preview" class="blog-comment">
+                    <fieldset>
+                      <legend>Comment preview</legend>
+                      <div class="comment-info">
+                        ${blog_comment.author} --
+                        ${format_datetime(blog_comment.time, '%Y-%m-%d %H:%M')}
+                      </div>
+                      <div class="comment_body">${wiki_to_html(context, blog_comment.comment)}</div>
+                    </fieldset>
+                  </div>
+                  <div class="field">
+                    <label for="comment">Comment (you may use
+                      <a tabindex="42" href="${href.wiki('WikiFormatting')}">WikiFormatting</a>
+                      here):
+                    </label><br />
+                    <textarea class="wikitext" id="comment" name="comment" 
+                      cols="80" rows="8">${defined('blog_comment') and blog_comment.comment or ''}</textarea>
+                  </div>
+                <py:if test="req.authname == 'anonymous'">
+                  <div class="field">
+                    <label for="author">Your email or username:</label>
+                      <br />
+                      <input id="author" type="text" 
+                          name="author" size="30"
+                          value="${defined('blog_comment') and blog_comment.author or req.authname}" />
+                  </div>
+                </py:if>
                 <div class="field">
-                  <label for="author">Your email or username:</label>
-                    <br />
-                    <input id="author" type="text" 
-                        name="author" size="30"
-                        value="${defined('blog_comment') and blog_comment.author or req.authname}" />
+                  <input size="30" type='submit' name="submitcomment"
+                      value="Add comment" />
+                  <input type="hidden" name="action" value="comment" />
+                  <input type="submit" name="previewcomment" value="Preview comment" />
+                  <input type="submit" name="cancelcomment" value="Cancel" />
                 </div>
-              </py:if>
-              <div class="field">
-                <input size="30" type='submit' name="submitcomment"
-                    value="Add comment" />
-                <input type="hidden" name="action" value="comment" />
-                <input type="submit" name="previewcomment" value="Preview comment" />
-                <input type="submit" name="cancelcomment" value="Cancel" />
-              </div>
-              <script type="text/javascript" src="${chrome.htdocs_location}js/wikitoolbar.js" />
-            </fieldset>
-          </form>
-          <p py:if="not 'BLOG_COMMENT' in perm(blog_post.resource)">
-            You do not have permission to add a comment.
-          </p>
+                <script type="text/javascript" src="${chrome.htdocs_location}js/wikitoolbar.js" />
+              </fieldset>
+            </form>
+          </div>
 
         </py:if> <!--! Single blog post rendering end -->
 