diff -r 8a0834803bd3 0.11/hierwiki/macros/subwiki.py
--- a/0.11/hierwiki/macros/subwiki.py	Tue Nov 09 17:24:27 2010 +0100
+++ b/0.11/hierwiki/macros/subwiki.py	Thu Nov 11 11:38:58 2010 +0100
@@ -13,17 +13,26 @@
     """
     Inserts an alphabetic list of sub-wiki pages into the output.
     A sub-wiki page is a page that is is deeper in the hierachy than the current page.  e.g. if the current page is People, the this will return a list of all wiki entries that start with "People/"
-    
-    Accepts a prefix string as parameter: if provided, only pages with names that
-    start with the prefix are included in the resulting list. If this parameter is
-    omitted, all pages are listed.
-    
-    This now takes the text of the first heading and displays it as the link name.
+   
+    Parameters: 
+    prefix: optional prefix string. If provided, only pages with names that
+        start with the prefix are included in the resulting list. If this 
+        parameter is omitted, all pages are listed.
+    level: optional, how many 'levels' to go down in hierarchy (default:
+        0 i.e. unrestricted) 
+    style: optional output style parameter (default: 1). Possible styles:
+        0: pagename, title
+        1: short pagename, title
+        2: title
+        3: pagename
+        4: short pagename
+    reverse: optional boolean parameter, reverse page sorting (default: False) 
     """
     good_pages = []
     index = 0
     href = 0
     style = 1
+    reverse = False
 
     TITLE_RE = re.compile(r'=+\s([^=]*)=+')
 
@@ -42,15 +51,18 @@
         if args:
             args = args.replace('\'', '\'\'')
             args = args.split(',')
-            if args[0] != None and args[0].strip() != '':
+            if args[0] != 'None' and args[0].strip() != '':
                 prefix = args[0]
                 
-            if len(args) > 1 and args[1] != None and args[1].strip() != '':
+            if len(args) > 1 and args[1] != 'None' and args[1].strip() != '':
                 level = int(args[1])
                 
-            if len(args) > 2 and args[2] != None and args[2].strip() != '':
+            if len(args) > 2 and args[2] != 'None' and args[2].strip() != '':
                 self.style = int(args[2])
 
+            if len(args) > 3 and args[3] != 'None' and args[3].strip() != '':
+                self.reverse = bool(args[3])
+
         if(prefix == '/'):
             prefix = ''
 
@@ -71,6 +83,9 @@
             self.good_pages.append((p, title, len_name[len(len_name)-1]))
         
         self.good_pages.sort()
+        # 0.11 supports Python 2.3 which has no .sort(reverse=True) keyword arg
+        if self.reverse:
+            self.good_pages.reverse()
         self.href = formatter.context.href
         self.log.debug('HierWikiPlugin: Found %r valid pages below', len(self.good_pages))
         self.index = 0
diff -r 8a0834803bd3 0.12/hierwiki/macros/subwiki.py
--- a/0.12/hierwiki/macros/subwiki.py	Tue Nov 09 17:24:27 2010 +0100
+++ b/0.12/hierwiki/macros/subwiki.py	Thu Nov 11 11:38:58 2010 +0100
@@ -13,17 +13,26 @@
     """
     Inserts an alphabetic list of sub-wiki pages into the output.
     A sub-wiki page is a page that is is deeper in the hierachy than the current page.  e.g. if the current page is People, the this will return a list of all wiki entries that start with "People/"
-    
-    Accepts a prefix string as parameter: if provided, only pages with names that
-    start with the prefix are included in the resulting list. If this parameter is
-    omitted, all pages are listed.
-    
-    This now takes the text of the first heading and displays it as the link name.
+   
+    Parameters: 
+    prefix: optional prefix string. If provided, only pages with names that
+        start with the prefix are included in the resulting list. If this 
+        parameter is omitted, all pages are listed.
+    level: optional, how many 'levels' to go down in hierarchy (default:
+        0 i.e. unrestricted) 
+    style: optional output style parameter (default: 1). Possible styles:
+        0: pagename, title
+        1: short pagename, title
+        2: title
+        3: pagename
+        4: short pagename
+    reverse: optional boolean parameter, reverse page sorting (default: False) 
     """
     good_pages = []
     index = 0
     href = 0
     style = 1
+    reverse = False
 
     TITLE_RE = re.compile(r'=+\s([^=]*)=+')
 
@@ -42,15 +51,18 @@
         if args:
             args = args.replace('\'', '\'\'')
             args = args.split(',')
-            if args[0] != None and args[0].strip() != '':
+            if args[0] != 'None' and args[0].strip() != '':
                 prefix = args[0]
                 
-            if len(args) > 1 and args[1] != None and args[1].strip() != '':
+            if len(args) > 1 and args[1] != 'None' and args[1].strip() != '':
                 level = int(args[1])
                 
-            if len(args) > 2 and args[2] != None and args[2].strip() != '':
+            if len(args) > 2 and args[2] != 'None' and args[2].strip() != '':
                 self.style = int(args[2])
 
+            if len(args) > 3 and args[3] != 'None' and args[3].strip() != '':
+                self.reverse = bool(args[3])
+
         if(prefix == '/'):
             prefix = ''
 
@@ -70,7 +82,7 @@
 
             self.good_pages.append((p, title, len_name[len(len_name)-1]))
         
-        self.good_pages.sort()
+        self.good_pages.sort(reverse=self.reverse)
         self.href = formatter.context.href
         self.log.debug('HierWikiPlugin: Found %r valid pages below', len(self.good_pages))
         self.index = 0