Index: tracscreenshots/core.py
===================================================================
--- tracscreenshots/core.py	(revision 4338)
+++ tracscreenshots/core.py	(working copy)
@@ -100,7 +100,7 @@
             return True
         match = re.match(r'''^/screenshots/(\d+)$''', req.path_info)
         if match:
-            req.args['action'] = 'get-file'
+            req.args['screenshots_action'] = 'get-file'
             req.args['id'] = match.group(1)
             return True
         return False
@@ -137,7 +137,7 @@
     # Internal functions.
 
     def _get_actions(self, context):
-        action = context.req.args.get('action')
+        action = context.req.args.get('screenshots_action')
         self.log.debug('action: %s' % (action,))
         if action == 'get-file':
             return ['get-file']
Index: tracscreenshots/templates/screenshot.html
===================================================================
--- tracscreenshots/templates/screenshot.html	(revision 4338)
+++ tracscreenshots/templates/screenshot.html	(working copy)
@@ -53,7 +53,7 @@
         <form method="post" action="${href.screenshots()}">
           <div>
             <input type="submit" name="edit" value="Edit"/>
-            <input type="hidden" name="action" value="edit"/>
+            <input type="hidden" name="screenshots_action" value="edit"/>
             <input type="hidden" name="id" value="${screenshots.screenshot.id}"/>
           </div>
         </form>
@@ -61,7 +61,7 @@
           <div>
             <input type="submit" name="delete" value="Delete"/>
             <input type="hidden" name="id" value="${screenshots.screenshot.id}"/>
-            <input type="hidden" name="action" value="delete"/>
+            <input type="hidden" name="screenshots_action" value="delete"/>
           </div>
         </form>
       </div>
Index: tracscreenshots/templates/screenshots.html
===================================================================
--- tracscreenshots/templates/screenshots.html	(revision 4338)
+++ tracscreenshots/templates/screenshots.html	(working copy)
@@ -20,14 +20,14 @@
         <form method="post" action="${href.screenshots()}">
           <div>
             <input type="submit" name="add" value="Add"/>
-            <input type="hidden" name="action" value="add"/>
+            <input type="hidden" name="screenshots_action" value="add"/>
             <input type="hidden" name="index" value="${screenshots.index}"/>
           </div>
         </form>
         <form py:if="len(screenshots) > 0 and index" method="post" action="${href.screenshots()}">
           <div>
             <input type="submit" name="edit" value="Edit"/>
-            <input type="hidden" name="action" value="edit"/>
+            <input type="hidden" name="screenshots_action" value="edit"/>
             <input type="hidden" name="id" value="${screenshots.id}"/>
             <input type="hidden" name="index" value="${screenshots.index}"/>
           </div>
@@ -37,7 +37,7 @@
             <input type="submit" name="delete" value="Delete"/>
             <input type="hidden" name="id" value="${screenshots.id}"/>
             <input type="hidden" name="index" value="${screenshots.index}"/>
-            <input type="hidden" name="action" value="delete"/>
+            <input type="hidden" name="screenshots_action" value="delete"/>
           </div>
         </form>
       </div>
@@ -89,7 +89,7 @@
 
             <div class="buttons">
               <input type="submit" name="filter" value="Apply Filter"/>
-              <input type="hidden" name="action" value="filter"/>
+              <input type="hidden" name="screenshots_action" value="filter"/>
             </div>
 
           </fieldset>
Index: tracscreenshots/templates/screenshot-add.html
===================================================================
--- tracscreenshots/templates/screenshot-add.html	(revision 4338)
+++ tracscreenshots/templates/screenshot-add.html	(working copy)
@@ -14,15 +14,15 @@
       <form class="add_form" method="post" enctype="multipart/form-data" action="${href.screenshots()}">
         <fieldset>
           <legend>
-            ${(req.args.action == 'add') and 'Add Screenshot:' or 'Edit Screenshot'}
+            ${(req.args.screenshots_action == 'add') and 'Add Screenshot:' or 'Edit Screenshot'}
           </legend>
           <div class="field">
             <label for="name">Name:</label><br/>
-            <input type="text" id="name" name="name" value="${(req.args.action == 'edit') and screenshots.screenshot.name or ''}"/><br/>
+            <input type="text" id="name" name="name" value="${(req.args.screenshots_action == 'edit') and screenshots.screenshot.name or ''}"/><br/>
           </div>
           <div class="field">
             <label for="description">Description:</label><br/>
-            <input type="text" id="description" name="description" value="${(req.args.action == 'edit') and screenshots.screenshot.description or ''}"/><br/>
+            <input type="text" id="description" name="description" value="${(req.args.screenshots_action == 'edit') and screenshots.screenshot.description or ''}"/><br/>
           </div>
           <div class="field">
             <label for="image">Image File:</label><br/>
@@ -30,14 +30,14 @@
           </div>
           <div py:if="screenshots.has_tags" class="field">
             <label for="tags">Additional tags:</label><br/>
-            <input type="text" id="tags" name="tags" value="${(req.args.action == 'edit') and screenshots.screenshot.tags or ''}"/><br/>
+            <input type="text" id="tags" name="tags" value="${(req.args.screenshots_action == 'edit') and screenshots.screenshot.tags or ''}"/><br/>
           </div>
           <div class="field">
             <label for="components">Components:</label><br/>
             <select id="components" name="components" multiple="on">
               <py:for each="component in screenshots.components">
                 <py:choose>
-                  <option py:when="(req.args.action == 'edit') and (component.name in screenshots.screenshot.components)" value="${component.name}" selected="selected">${component.name}</option>
+                  <option py:when="(req.args.screenshots_action == 'edit') and (component.name in screenshots.screenshot.components)" value="${component.name}" selected="selected">${component.name}</option>
                   <option py:otherwise="" value="${component.name}">${component.name}</option>
                 </py:choose>
               </py:for>
@@ -48,7 +48,7 @@
             <select id="versions" name="versions" multiple="on">
               <py:for each="version in screenshots.versions">
                 <py:choose>
-                  <option py:when="(req.args.action == 'edit') and (version.name in screenshots.screenshot.versions)" value="${version.name}" selected="selected">${version.name}</option>
+                  <option py:when="(req.args.screenshots_action == 'edit') and (version.name in screenshots.screenshot.versions)" value="${version.name}" selected="selected">${version.name}</option>
                   <option py:otherwise="" value="${version.name}">${version.name}</option>
                 </py:choose>
               </py:for>
@@ -57,9 +57,9 @@
           <div class="buttons">
             <input type="submit" name="submit" value="Submit"/>
             <input type="button" name="cancel" value="Cancel" onclick="history.back()"/>
-            <input type="hidden" name="id" value="${(req.args.action == 'edit') and screenshots.screenshot.id or ''}"/>
+            <input type="hidden" name="id" value="${(req.args.screenshots_action == 'edit') and screenshots.screenshot.id or ''}"/>
             <input type="hidden" name="index" value="${screenshots.index}"/>
-            <input type="hidden" name="action" value="${(req.args.action == 'add') and 'post-add' or 'post-edit'}"/>
+            <input type="hidden" name="screenshots_action" value="${(req.args.screenshots_action == 'add') and 'post-add' or 'post-edit'}"/>
           </div>
         </fieldset>
       </form>
Index: tracscreenshots/templates/screenshots-matrix-view.html
===================================================================
--- tracscreenshots/templates/screenshots-matrix-view.html	(revision 4338)
+++ tracscreenshots/templates/screenshots-matrix-view.html	(working copy)
@@ -22,8 +22,8 @@
                 <div py:if="'SCREENSHOTS_ADMIN' in perm" class="controls">
                   <py:choose>
                     <py:when test="image.id != -1">
-                      <a href="${href.screenshots()}?action=edit;id=${image.id};index=${screenshots.index}">Edit</a>
-                      <a href="${href.screenshots()}?action=delete;id=${image.id};index=${screenshots.index}">Delete</a>
+                      <a href="${href.screenshots()}?screenshots_action=edit;id=${image.id};index=${screenshots.index}">Edit</a>
+                      <a href="${href.screenshots()}?screenshots_action=delete;id=${image.id};index=${screenshots.index}">Delete</a>
                     </py:when>
                     <py:otherwise>
                       &nbsp;